#Prepare chart by selecting the data   # www.Tricks12345.com
from tkinter import *
from tkinter.ttk import *
from tkinter import Tk
import tkinter as tk
import datetime
from tkinter import messagebox
from selenium import webdriver
import time
import matplotlib
from matplotlib import pyplot as plt

class ImportData_PrepareCharts:
    def __init__(self):
        self.driver = webdriver.Chrome()
        self.driver.maximize_window()
        self.layout = Tk()
        self.layout.geometry('500x500')
        self.layout.title('select the Data from List box')
        self.plt = matplotlib.pyplot
        self.labl1 = Label(self.layout, text = 'Select the Data', font=("calibri", 15,  "bold"))
        self.labl1.grid(column = 0, row = 1)
 
        self.combo = Combobox(self.layout, width = 25)
        self.combo.grid(column = 0, row = 2)
 

        self.scrollbar = Scrollbar(self.layout, orient=tk.VERTICAL)
        self.scrollbar.grid(column = 1, row = 0, sticky=tk.N+tk.S)
        self.listbox = Listbox(self.layout, selectmode = MULTIPLE, yscrollcommand=self.scrollbar.set, width = 25)
        self.listbox.grid(column = 0, row = 0)
        self.scrollbar.config(command=self.listbox.yview) 
        self.labl2 = Label(self.layout, text = 'List of Companies', font=("calibri", 15,  "bold"))
        self.labl2.grid(column = 2, row = 0)
         
        self.btn = Button(self.layout, text = 'Insert the Data',command = self.EnterDataIntoListbox)    
        self.btn.grid(column = 2, row = 1)

        self.btn1 = Button(self.layout, text = 'Retrieve Data',command = self.GetDatafromBoxes)    
        self.btn1.grid(column = 2, row = 2)

        self.btn2 = Button(self.layout, text = 'Create Chart',command = self.CreateChart)    
        self.btn2.grid(column = 2, row = 3)

        self.TotalHeaders = []
        self.tabledata = []
        self.companynames = []
        self.Header = ""
        self.companyIndexes = []
        self.totalrows = []
        self.yaxisdata = []
        self.companyList = []
        self.chartname = 1
        
    def Connect_To_Web(self):
        url = 'https://www.nseindia.com/live_market/dynaContent/live_watch/equities_stock_watch.htm'
        self.driver.get(url)  
        time.sleep(3) 
        
    def click_on_Livemarket(self):                        
            self.totalrows = self.driver.find_element_by_id('dataTable').find_elements_by_tag_name('tr')            
            r =1
            for row in self.totalrows:           
                colcount = len(row.find_elements_by_tag_name('th'))
                for c,col in enumerate(row.find_elements_by_tag_name('th')):
                    self.TotalHeaders.append(col.text)
                    if c == 0 or c == 1 or c ==2 or c == 13 or c == 15:
                            continue
                    self.tabledata.append(col.text)
                if r >=3:
                    for i,col in enumerate(row.find_elements_by_tag_name('td')):
                        if i == 0:
                            self.companynames.append(col.text)
                r = r+1

    def EnterDataIntoListbox(self):         
           self.combo['values'] =  self.tabledata
           self.combo.current(1)
           for c in (self.companynames):
                self.listbox.insert(END,c)           
           self.layout.mainloop()
    
    def GetDatafromBoxes(self):                    
           self.Header =  self.combo.get()
           compLen = 0
           compLen = len(self.listbox.curselection())           
           for i in range(compLen):
                m = self.listbox.curselection()[i]
                self.companyIndexes.append(m)
                self.companyList.append(self.listbox.get(m))
           print(self.companyList)
           
    def CreateChart(self):                                
            print(self.TotalHeaders)
            HeaderIndex = self.TotalHeaders.index(self.Header)
            rowdata = self.driver.find_element_by_id('dataTable').find_elements_by_tag_name('tr') 
            print(self.companyIndexes)
            for i in range(len(self.companyIndexes)):
                RowNumber = self.companyIndexes[i]
                d = rowdata[RowNumber+2].find_elements_by_tag_name('td')[HeaderIndex].text
                output = d.replace(',','')
                self.yaxisdata.append(float(output))                 
            self.plt.bar(self.companyList,self.yaxisdata, color = 'r', label = self.Header)
            print(self.yaxisdata)      
            self.plt.title('NSE stock data')
            self.plt.legend()
            self.plt.savefig('./static/NSEData.png')
            self.plt.show()                            
             
            
z = ImportData_PrepareCharts()
z.Connect_To_Web() 
z.click_on_Livemarket()
 
